//
// DHTML쓮NX
// DHTMLŋLqꂽ UI NX̋@\ĂяoĎs邱Ƃł
//
#include <windows.h>
#include <atlbase.h>
CComModule _Module;
#include <atlwin.h>
#include <atlcom.h>
#include <atlhost.h>

/**
 * DHTML̊Oďo󗝂NX
 * NX܂Ă (CMyWindow Œ public IDispatch)
 * Ƃ̂ŕB͕s
 */ 
class CHtmlExt : public IDispatch {

public:

	//----------------------------------------------------------------------------
	// IUnknown 
	
	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
											 void __RPC_FAR *__RPC_FAR *ppvObject) {
		if (riid == IID_IUnknown || riid == IID_IDispatch) {
			if (ppvObject == NULL)
				return E_POINTER;
			*ppvObject = this;
			AddRef();
			return S_OK;
		} else {
			*ppvObject = 0;
			return E_NOINTERFACE;
		}
	}

	ULONG STDMETHODCALLTYPE AddRef() {
		return 1;
	}

	ULONG STDMETHODCALLTYPE Release() {
		return 1;
	}

	//----------------------------------------------------------------------------
	// IDispatch 

	STDMETHOD(GetTypeInfoCount)(UINT* pctinfo) {
		return E_NOTIMPL;
	}

	STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo** pptinfo) {
		return E_NOTIMPL;
	}

	enum {
		NONE = 0,
		SETBGCOLOR = 1,
	};

	/**
	 * \bhID̑ΉƂ郁\bh
	 * regszNames Ƀ\bh̔z񂪂̂ŁA
	 * rgdispid ɑΉ dispid ԂĂ
	 */
	STDMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames,
							 LCID lcid, DISPID* rgdispid) {
		UINT i;
		for (i=0; i<cNames; i++) {
			if (wcscmp(rgszNames[i], OLESTR("SetBgColor")) == 0) {
				rgdispid[i] = SETBGCOLOR;
			} else {
				rgdispid[i] = NONE;
			}
		}
		return S_OK;
	}

	/**
	 * \bhs
	 * dispidMember Ń\bhw肳B pdispparams  VARIANT ̔z
	 * ̌`ł킽̂łg
	 */
	STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
		LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
		EXCEPINFO* pexcepinfo, UINT* puArgErr) {
		switch (dispidMember) {
		case SETBGCOLOR:
			{
				// {͂ň`FbNKv
				//  2 (1:Body Element, 2: F)
				CComQIPtr<IHTMLBodyElement> spBody(pdispparams->rgvarg[1].pdispVal);
				if (spBody != NULL) {
					spBody->put_bgColor(pdispparams->rgvarg[0]);
				}
			}
			break;
		default:
			return E_NOTIMPL;
		}
		return S_OK;
	}
};

/**
 * HTMLR|[lgEChENX̎
 * CAxWindow gāAʂς IER|[lg쐬Ă
 */
class CMyWindow :
	public CWindowImpl<CMyWindow, CWindow>,
	public CHtmlExt
{	
public:
	CComPtr<IWebBrowser2> browser;
	
private:
	BEGIN_MSG_MAP(CMyWindow)
		MESSAGE_HANDLER(WM_CREATE,   OnCreate)
		MESSAGE_HANDLER(WM_DESTROY,  OnDestroy)
	END_MSG_MAP()

	LRESULT OnCreate(UINT, WPARAM, LPARAM, BOOL&) {
		// Rg[p
		CAxWindow wnd;
		RECT rect;
		// ̃TCYƓTCYɍ쐬
		GetClientRect(&rect);
		wnd.Create(m_hWnd, rect, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER, 0, 1);
		LPOLESTR pstrCLSID_WebBrowser = NULL;
		// Rg[쐬
		HRESULT hr = wnd.CreateControl(OLESTR("Shell.Explorer.2"));
		if (SUCCEEDED(hr)) {
			// g external pɓo^
			hr = wnd.SetExternalDispatch(static_cast<CHtmlExt*>(this));
		}
		if (SUCCEEDED(hr)) {
			// C^[tF[X擾
			hr = wnd.QueryControl(&browser);
		}
		return SUCCEEDED(hr) ? 0 : -1;
	}

	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&){
		if (browser) {
			// C^[tF[Xꍇ͉Ă
			browser.Release();
			browser.Detach();
		}
		// XXX AvP[VI
		PostQuitMessage(0);
		return 0;
    }
};

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	int ret;
	
	_Module.Init(NULL, hInstance);
	AtlAxWinInit();

	CMyWindow wnd;
	wnd.Create(NULL, CWindow::rcDefault, NULL,
			   WS_OVERLAPPEDWINDOW|WS_VISIBLE);
	
#if 0	
	{
		CComVariant vUrl("file://c:/htmlUI.htm");
		CComVariant vempty;
		wnd.browser->Navigate2(&vUrl, &vempty, &vempty, &vempty, &vempty);
	}
#else
	{
		// Ƃ肠hLg
		CComVariant vUrl("about:blank");
		CComVariant vempty;
		wnd.browser->Navigate2(&vUrl, &vempty, &vempty, &vempty, &vempty);

		// hLg擾āc
		CComPtr<IDispatch> pDisp ;
		wnd.browser->get_Document(&pDisp) ;
		CComQIPtr<IHTMLDocument2> pDoc = pDisp ;

		if (pDoc) {
			// eLXgȂ
			VARIANT *param;
			SAFEARRAY *sfArray = NULL;
			BSTR bstr = SysAllocString(OLESTR("<BODY style=\"overflow-y:hidden\" id=theBody><BUTTON onclick='window.external.SetBgColor(theBody, \"red\");'></BUTTON><BUTTON onclick='window.external.SetBgColor(theBody, \"green\");'></BUTTON></BODY>"));
			sfArray = SafeArrayCreateVector(VT_VARIANT, 0, 1);
			if (sfArray) {
				SafeArrayAccessData(sfArray,(LPVOID*) &param);
				param->vt = VT_BSTR;
				param->bstrVal = bstr;
				SafeArrayUnaccessData(sfArray);
				pDoc->write(sfArray);
				SafeArrayDestroy(sfArray);
			}
			SysFreeString(bstr);
		}
	}
#endif
	
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	ret = msg.wParam;

	_Module.Term();
	return ret;
}
